/*-------------------------------------------------------------------------*/

/*
 *	Delay functions
 *	See delay.h for details
 *
 *	Make sure this code is compiled with full optimization!!!
 */

#include	"delay.h"


/*-------------------------------------------------------------------------*/
void DelayMilisec(unsigned int cnt)

/*
 * delay millisec
 * try new
 * alm 9/19/07
 */

	{
#if XTAL_FREQ >16MHZ
	unsigned int	i;
	do
		{
		i = 100;

		do
			{
			DelayMicrosec(10);	/* 40MHZ XTAL  alm 9/19/07 */
			}
		while(--i);
		}
	while(--cnt);
#else
  asfsfsfsf ERROR!!!
#endif

	}

/*-------------------------------------------------------------------------*/
void DelayMs(unsigned char cnt)

	{
#if	XTAL_FREQ <= 2MHZ
	do
		{
		DelayUs(996);
		}
	while(--cnt);
#endif

#if XTAL_FREQ >16MHZ
	unsigned char	i;
	do
		{
		i = 100;

		do
			{
			DelayUs(10);
			}
		while(--i);
		}
	while(--cnt);
#else
 #if    XTAL_FREQ > 2MHZ
 	unsigned char	i;
 	do
 		{
 		i = 4;

 		do
 			{
 			DelayUs(250);
 			}
 		while(--i);
 		}
 	while(--cnt);
 #endif
#endif
	}


/*-------------------------------------------------------------------------*/
void DelayMicrosec(unsigned char timer)

/*
 *
 * FUNCTION
 *   DelayMicrosec
 *
 * PURPOSE
 *   Delay in microseconds @40 MHz. this is a brute force delay, and
 *   doesn't compensate for interrupts happening during its' execution.
 *
 * PARAMETERS
 *   unsigned char delay
 *
 * RETURNS
 *   Nothing.
 */

	{
    #asm
        delay:
            addlw   -1
            btfsc   status, 2
            return
            nop
            nop
            nop
            nop
            nop
  	#if defined (_18F4550)
            nop
	#endif
          goto delay
    #endasm
	}
/*-------------------------------------------------------------------------*/
